<template>
  <Container class="w-full">
    <SectionHeader icon="mdi-note-edit-outline">
      Заметки
    </SectionHeader>

    <section class="mt-4">
      <CreateGuestNoteForm @create="$note => emit('create:note', $note)" />
    </section>

    <EmptyState
      v-if="!notes.length"
      embedded
      class="mt-4 py-8 bg-gray-50"
    />

    <v-list
      v-show="notes.length"
      lines="two"
      class="mt-4"
    >
      <v-slide-y-transition
        group
        leave-absolute
      >
        <v-list-item
          v-for="(note, index) in notes"
          :key="note.id"
          :class="{ 'bg-gray-50': index % 2 === 0 }"
        >
          <template #prepend>
            <v-icon
              icon="mdi-text"
              size="small"
            />
          </template>

          <template #title>
            <span v-tooltip:top-start="{ text: note.text, openOnClick: true }">
              {{ note.text }}
            </span>
          </template>

          <template #subtitle>
            Добавлено {{ dt.display(note.createdAt) }}
          </template>

          <template #append>
            <DeleteGuestNoteForm
              :note="note"
              @delete="$noteId => emit('delete:note', $noteId)"
            />
          </template>
        </v-list-item>
      </v-slide-y-transition>
    </v-list>
  </Container>
</template>

<script setup lang="ts">
import { computed } from 'vue';

import { useDateTime } from '@/composables';

import EmptyState from '@/components/layout/EmptyState.vue';
import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';

import CreateGuestNoteForm from './CreateGuestNoteForm.vue';
import DeleteGuestNoteForm from './DeleteGuestNoteForm.vue';

const props = defineProps<{ notes: IGuest['notes'] }>();
const emit = defineEmits(['create:note', 'delete:note']);

const dt = useDateTime();

const notes = computed(() => {
  return props.notes.toSorted((noteA, noteB) => {
    return (
      dt.wrap(noteB.createdAt).toMillis() -
      dt.wrap(noteA.createdAt).toMillis()
    );
  });
});
</script>